﻿//-----------------------------------------------------------------------------
//
// Program.cs
//
//  USB Performance Monitor Application
//  Copyright (C) 2010 Simon Inns
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//  Web:    http://www.waitingforfriday.com
//  Email:  simon.inns@gmail.com
//
//-----------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;

using System.Threading;
using System.Runtime.InteropServices;

namespace USB_Performance_Monitor
    {
    static class Program
        {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
            {
            bool createdNew;

            Mutex m = new Mutex(true, "USB Performance Monitor", out createdNew);

            if (!createdNew)
                {
                // The application is already running...
                MessageBox.Show("Only one copy of the USB Performance Monitor application can be run at one time.",
                "USB Performance Monitor",
                MessageBoxButtons.OK,
                MessageBoxIcon.Exclamation);
                return;
                }

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new mainForm());

            // keep the mutex reference alive until the normal termination of the program
            GC.KeepAlive(m);
            }
        }
    }
